/* c:\tc\email\slalom.cpp                               14.3.96


   Swing with seven amplitudes around trees scrolling in from the top.

	Program RnESwng.Bas generates a File Swing-Or.001
	Program ComESwng.Cpp combines these data with File Swinglet
	into File SwingDat.001. Here the assignment bit is set to 1.
	(This is for the case without external observer.)
	Before use, rename SwingDat.001 into SwingDat.
	At the first Recorded Run a File SwingDat.Psi is generated.

   Input Data File: Slal-Dat.psi  for up to 100 trials.
	Subject has additional option for high/low amplitude

   Optional inclusion of external observer:

   Convenient display of all Test Runs and recent Play Runs.

   New Terminology:  Explore-Run vs. Record-Run
*/
#include <conio.h>	//getch()
#include <dos.h>
#include <time.h>
#include <math.h>      	// abs(), labs()
#include <stdlib.h>  	// randomize
#include <graphics.h>
#include <iostream.h>   //cout<<
#include <stdio.h>	// FILE
#include <fstream.h>
#include <io.h>		//access
#define SETMODE 0
#define VIDEO 0x10

#define MAXR 200		// rows
#define MAXC 320		// columns
#define MAXB (MAXC/8)		// bytes in a row
#define ob outportb
#define ot outtextxy

int Anzahl;      // Number of available Game Runs
int unit;
int left;
char dat[] = "slal-dat";   	//fptr
char datpsi[] = "slal-dat.psi"; //fpdat
char druck[] = "prntsla.psi";   //fprint
char typus[] = "27496385sla-001/";//is updated and used as head of
prntswg.psi
FILE *fptr, *fpdat, *fprnt;
int hasfile;            // 1 if SwingDat.Psi exists, 0 else
int hasprint;
int runsleft;
unsigned char ch, cha, ch0;
char zeit[16];
char Ito[17]; 	// for itoa
int i,j,k,l,si,q;
int jmp;
int aim; // 0/1 for high/low aim
int assign; // 0/1 for assign from observer high/low
int cycle;
int colr; // trace color
int cycles = 50; // number of half cycles in run
int pzeiger; // Counts play score print position 0,1,..19
int pcount; // counts number of play runs
int amp;      // Swing amplitude amp =1,2,...,7
float S[128];
int T[128][8];
float xx,yy,zz,zf;
char far *farptr;
int row, col,x,y,z,M0,M1,s;
int b[] = {128,64,32,16,8,4,2,1};
unsigned char color;
int addr,A,score=0,speed=4,test=0;  // test = 0/1 for Play/Test
int gdriver, gmode,mode;
char chp[17]; // for itoa
char tst1[] = "Record-Run";
char tst0[] = "Explore-Run";
char tst2[] = "Explore-Runs Only";
char tst3[] = "High Swing";
char tst4[] = "Low Swing";
char* tst = tst0;
char* atst = tst3;
char ListA[5][16] = {"alert       \0","sleepy      \0",
		    "hard-pushing\0","meditating  \0"};
int att = 1;     // attitude
int fast = 0;  // set fast = 1 for speedup
int spd[] = {16,8,4,2,0,16,8,4,2,0};
int playsc[20],playsc2[20],testsc[100];
long int SeedM[100], SeedS[100],Rn,RnM,RnS,SdS,SdM;
long int P = 524287; // prime 2^19 - 1
int PA = 79, PB = 3067;
int stop;
double sigma = 53.808;  // from program swngmath.cpp
// ...................................................................

void p(int jc,char* pt)		// Print line of text
   {gotoxy(1,jc); cputs(pt);}

int iszahl(unsigned char c0)		//  48..57  65..70 (ASCII)
   { int is1=1;                         //   0...9   A...F
     if(c0<48 || c0>70 || (c0<65 && c0>57)) is1=0;
     return is1;
   }

int Getc(FILE *fp)    // ignore non-hex-numbers
   { int gtc = 0, gt;
     while(gtc==0) { gt = getc(fp); gtc = iszahl(gt);}
     return gt;
   }


int GetBit()
    {
       RnM = (RnM*PA) % P; RnM = (RnM*PB) % P;
       unsigned int hold1 = (RnS & 1) << 3;
       hold1 = (RnS & 8) ^ hold1;
       RnS = RnS >> 1;
       if(hold1 & 8) RnS = RnS | 0x100;
       Rn = (RnS ^ RnM) & 1;		// need only binary decision
       if(assign==0) Rn = 1 - Rn;
       return Rn;
    }

void Shift()
   {   unsigned int hold1 = (RnS & 1) << 3;
       hold1 = (RnS & 8) ^ hold1;
       RnS = RnS >> 1;
       if(hold1 & 8) RnS = RnS | 0x100;
   }


int TotScore(int ii)
{       RnS = (SeedS[ii]<<1)+1;
	assign = SeedM[ii] & 1;
	RnM = 0x301 | SeedM[ii];
	GetBit();
	amp = 4; score = 0;
	for(cycle=0;cycle<cycles;cycle++)
	{ amp = amp + 2*GetBit()-1;
	  if(amp>7) amp = 7;
	  if(amp<1) amp = 1;
	  score = score + amp - 4;
	 }
	 score = (int) ((100.0*score)/sigma);
	 return score;
}

void getzeit()
     {                         // Enters current time into zeit[15]
	zeit[15] = '\0';
	struct tm *ptr;
	time_t lt;
	lt = time(NULL);
	ptr = localtime(&lt);
	for(int j=0;j<15;j++) zeit[j] = asctime(ptr)[j+4];
     }


int makezahl(char ch)          // transform char 0,1,..,F into number
   { int anz = ((int)ch)-48;
     if (anz > 16) anz -=7;
     return anz;            }


unsigned int holint()
    {
	unsigned int uni = makezahl(getc(fpdat)); uni = uni <<4;
	uni += makezahl(getc(fpdat));
	return uni;
    }

unsigned int makehex(unsigned int xx) // ret.lowest 4 bits of xx as Ascii-Hex
    {  xx = xx & 15; xx += 48; if(xx>57) xx += 7; return xx; }


char makechar(int nn)         //     Number 0,1,...,15 -> char 0,...,F
   { nn += 48; if(nn > 57) nn += 7;
     return (char)nn;              }


void AllScroll()
{
ob(0x3c4,2);   //	select MAP MASK Register: vital for scroll
ob(0x3c5,0xf); //	activate all planes:else only some colors scroll ?
ob(0x3ce,5); // select MODE Register
ob(0x3cf,1); // set MODE 1
*(farptr+8000) = *(farptr+2540+80*fast); //2540=63*40+20  8000 outside screen
for(j=63;j>0;j--)  *(farptr+j*40+20) = *(farptr+j*40-20-40*fast);
*(farptr+20) = *(farptr+8000);
if(fast) *(farptr+60) = *(farptr+8000);

for(register line=199;line>(63- fast);line--)
   {	for(register add=6;add<34;add++)
	{ M0 = line*MAXB; M1 = (line-1- fast)*MAXB;
	 *(farptr+add+M0) = *(farptr+add+M1); }
   }
ob(0x3ce,5);
ob(0x3cf,0); //set write mode 0
if(spd[speed]>0) delay(spd[speed]);
}

void Rein(int x0)
      { A = amp; if(aim==1) A = 8 - amp;
	y = T[x0][A]/8; z = T[x0][A] % 8;
	*(farptr+y+MAXB*(64+4*fast)) = b[z]; }

void PN(int zx)  // print integer number in color text mode
	{cputs(itoa(zx,chp,10));}


void Settree()
   {	for(addr=0;addr<MAXB*MAXC;addr++) *(farptr+addr)=0;// clear all
	color = 10;
	ob(0x3C4,2);	  // set color to write
	ob(0x3C5,color);     //   into map mask register
	j=0; *(farptr+20+40*(j+26))= 0x3c;
	j=1; *(farptr+20+40*(j+26))= 0x7e;
	j=2; *(farptr+20+40*(j+26))= 0xff;
	j=3; *(farptr+20+40*(j+26))= 0xff;
	j=4; *(farptr+20+40*(j+26))= 0xff;
	j=5; *(farptr+20+40*(j+26))= 0xff;
	j=6; *(farptr+20+40*(j+26))= 0x7e;
	j=7; *(farptr+20+40*(j+26))= 0x3c;
   }

// .....................................................................

void main()
{
//			I am using my extended Graphics.Lib to get
//                      a stand-alone program with the next two lines

if (registerbgidriver(EGAVGA_driver) < 0) exit(1);
if (registerbgifont(sansserif_font) < 0) exit(1);
pzeiger = pcount = 0; // counts play runs
randomize();
//                                               Next generate sine Tables
for(x=0;x<64;x++)
  { zf = sin(x*2*M_PI/128.0);S[x]= zf; S[x+64] = -zf;}
for(x=0;x<128;x++) T[x][7] = 164 + (int) 105*sin(x*M_PI/64.0);
for(x=0;x<128;x++) T[x][6] = 164 + (int)  90*sin(x*M_PI/64.0);
for(x=0;x<128;x++) T[x][5] = 164 + (int)  75*sin(x*M_PI/64.0);
for(x=0;x<128;x++) T[x][4] = 164 + (int)  60*sin(x*M_PI/64.0);
for(x=0;x<128;x++) T[x][3] = 164 + (int)  45*sin(x*M_PI/64.0);
for(x=0;x<128;x++) T[x][2] = 164 + (int)  30*sin(x*M_PI/64.0);
for(x=0;x<128;x++) T[x][1] = 164 + (int)  15*sin(x*M_PI/64.0);
speed = 4; //...........................................temp

for(j=0;j<20;j++) playsc[j] = 0;
for(j=0;j<100;j++) testsc[j] = 0;

	    unsigned long Q = 0;
	    unsigned long lock = (9+16*(4+16*(7+2*16)));
	    lock = 6+16*lock;
	    lock = 3+16*lock;
	    lock = 8+16*lock;
	    lock = 5+16*lock;  // lock = HEX{27496385}

clrscr();
randomize();
test = 0;

//......................................................
hasfile = 0;      // Test if data file is present, set hasfile = 0/1
if(!access(datpsi,0)) hasfile=1;// needs io.h  (Compl.Refer.pg346)
			// access(. ,0) = 0 if file is present !
long ofdat = 0, ofin = 0;
int anf = 0, ende = 0;
//.................... generate file movedat.psi if appropriate........
if(!hasfile && !access(dat,0))
  {      fpdat = fopen(datpsi,"wb");	//movedat.psi
	 fptr  = fopen(dat,"rb+");       //movedat
	 // needs BINARY file to make ftell(fpdat) work right
	 fprnt = fopen(druck,"w");      //prntmove
	 fseek(fptr,ofin,0);
	 fseek(fpdat,ofdat,0);
     while(!feof(fptr) )
	    {  if(!feof(fptr)) {ch = getc(fptr); }
	      if(iszahl(ch)) { Q = Q<<4; Q += makezahl(ch);} else Q=0;
	      if(Q == lock) {ende=1;break;}
	    }
  if(ende)
   { ofin = ftell(fptr)-8; fseek(fptr,ofin,0);
		// sets file pos.indicater to start of code 274..
     for(i=0;i<16;i++){ch=getc(fptr);putc(ch,fpdat);typus[i]=ch;}
     for(i=0;i<2;i++) {ch=Getc(fptr);putc(ch,fpdat);}
     ch0 = '0'; for(i=0;i<2;i++) putc(ch0,fpdat);
     fprintf(fprnt,"%s",typus);  fclose(fprnt);
     i=0;
     while(!feof(fptr))
	    {  if(!feof(fptr)) ch = getc(fptr);
	       if(iszahl(ch))
		{i=(i+1)%8; putc(ch,fpdat);
		 if(i==0){putc(ch0,fpdat);putc(ch0,fpdat);}}
	    }
     // disable the file slal-dat by changing the code 27496385 -> 07496..
     fseek(fptr,ofin,0); ch = '0'; putc(ch,fptr);
     fclose(fptr);fclose(fpdat);
     hasfile = 1;
   }
  }

if(hasfile)
{	fpdat = fopen(datpsi,"r+");
	int ofdat = 16; fseek(fpdat,ofdat,0);
	Anzahl = holint();
	unit = holint();
	runsleft = Anzahl - unit; // if full then unit = Anzahl
  for(int uni=0;uni<Anzahl;uni++)
	  { ofdat = 20+ 10*uni; fseek(fpdat,ofdat,0);
			SdS = holint();
			SdS = SdS << 8;
			SdS += holint();
			SdM = holint();
			SdM = SdM << 8;
			SdM += holint();
			SeedS[uni] = SdS;
			SeedM[uni] = SdM;
	   }
	 fclose(fpdat);
}

SdS = random(256);SdM = random(256);
RnS = (SdS << 1) + 1; RnM = SdM | 0x0300;

//............... First Page at Power-Up ............................
clrscr();
//for(q=0;q<16;q++) {textcolor(q);gotoxy(20+2*q,1);cputs("X");}
textcolor(13);
p(2,"                            Experiment:  SLALOM");
for(j=0;j<32;j++) {q = j % 8 + 8;textcolor(q);gotoxy(22+j,4);cputs(".");}
textcolor(11);
p(7,"                              Helmut Schmidt");
p(8,"                                P.O.Box 296");
p(9,"                              Mora, NM 87732");
p(10,"                              (505) 387-2184");
p(11,"                            psischmidt@aol.com");
textcolor(10);
p(15,"          See the File README for General Information on the
Experiments");
p(17,"          Read File Slalom.Txt for Details on this Experiment SLALOM");
p(19,"              Turn the Printer on if you want a Printed Record");
textcolor(11);
if(!hasfile)
{ p(21,"                    No Data Files: Only Explore-Runs are
available.");}
else { p(21,"                 Number of still Available Record-Runs :");
       gotoxy(60,21);cputs(itoa(runsleft,Ito,10));}
textcolor(14);
p(24," Press X to EXIT Program.                       Press any Key to
Continue");
ch0 = getch(); if(ch0=='X' || ch0=='x') exit(0);
//..................................................................

//                  Instruction Page. Text 80 x 25.
clrscr();
textcolor(13);
p(1,"                       Slalom Experiment");
textcolor(10);
p(3," You will see a colored trace swinging around a row of green squares.");
p(5," You may imagine yourself in the role of a skier slaloming around
trees.");
p(6," You have the option of two goals:");
p(8,"    If you select High Swing you try to have the trace swing with");
p(9,"    high amplitudes, slaloming away from the trees in wide swings.");
p(10,"    For wide swings the color of the trace turns bright yellow.");
p(12,"    If you select Low Swing you try to keep the trace as closely to");
p(13,"    the trees as possible. For such low amplitude swings the color
of");
p(14,"    the trace turns rust-red.");
p(16," The run ends after you have passed 50 trees. A positive score");
p(17," indicates success, the higher the better.");
textcolor(13);
p(19," The program allows for 'Explore-Runs' with scores saved only until");
p(20," the computer is turned off, and for a total of 100 'Record-Runs'");
p(21," with permanently saved scores.");
textcolor(11);
p(24,"                                        Press any key to continue");
getch();

//                             The next page offers selection choices.
//                             Test-Play, Speed, FullScore Display.
score=0;
Setdat:
closegraph();  // needed to cancel repeated initgraph()
gdriver = VGA; gmode = VGAMED;  // screen 640 x 350
initgraph(&gdriver, &gmode," ");
setcolor(14);
settextstyle(3,0,2);
outtextxy(10,10,"Score = ");outtextxy(110,10,itoa(score,chp,10));
settextstyle(3,0,1);setcolor(7);
if(hasfile && (unit<Anzahl))
  { ot(250,10,"Number of Record-Runs left:");
    left = Anzahl-unit; if(left<0) left = 0;
    ot(520,10,itoa(left,chp,10));}
else ot(250,10,"No Record-Runs Available");
setcolor(13);
ot(0,50,"Make your selections by pressing the listed letter or number");
setcolor(10);ot(10,85,"Select Explore or Record-Mode:");
setcolor(14);ot(420,85,"M");
setcolor(10);ot(10,118,"Select HIGH or LOW Swing as Goal:");
setcolor(14);ot(420,115,"G");
setcolor(10);ot(10,145,"Select an Attitude or Mental Approach:");
setcolor(14);ot(420,145,"A");
setcolor(10);
ot(10,175,"Push                [fastest] to set a speed");
setcolor(14);ot(70,175,"0,1,2,3,4");
setcolor(13);ot(460,175,"Speed: ");
setcolor(7);settextstyle(0,0,0);
ot(10,205,"      [If that is too slow use range 5,..,9]");
settextstyle(3,0,1);
setcolor(10); ot(10,215,"For Summary of past Scores press:");
setcolor(14); ot(420,215,"S");
setcolor(10); ot(10,245,"To EXIT Program Press:");
setcolor(14); ot(420,245,"X");
setcolor(13);
ot(10,280,"              To START the Run press ENTER, ENTER");
setcolor(7);
settextstyle(0,0,0);
//outtextxy(80,318,"An Explore-Run may be interrupted by pressing ENTER.");
settextstyle(3,0,1);
NewSpeed:
setcolor(13);ot(460,85,tst);
setcolor(13);ot(460,115,atst);
setcolor(13);ot(460,145,ListA[att]);
outtextxy(530,175,itoa(speed,chp,10));
while(!kbhit()) { Shift();}
j = getch();
if((j>47) && (j<58))
	{setcolor(0);outtextxy(530,175,itoa(speed,chp,10));
	speed =j-48; fast=0; if (speed>4) fast=1;goto NewSpeed;}
j &= 0xdf;
if(j==77) {test = (1-test)*hasfile*(unit<100); // PLAY if no File or Full
	   setcolor(0); outtextxy(460,85,tst); // clear display area
	   if(test) tst = tst1; else tst = tst0;
	   if(!(hasfile && (unit<100))) tst = tst2;
	   outtextxy(460,85,tst); goto NewSpeed; }
if(j==71) { aim = (1-aim); atst = tst3; if(aim==1) atst = tst4;
	    setcolor(0);outtextxy(460,115,tst3);outtextxy(460,115,tst4);
	    goto NewSpeed;}
if(j==65) { setcolor(0);outtextxy(460,145,ListA[att]);
	    att = (att+1) % 4; goto NewSpeed;}// up to 8 attitudes
if(j==83) goto ScoreDisplay;           // for S choice
if(j==13) { goto Anfang;}
if(j!=88) goto NewSpeed;            // Exit for X choice
closegraph(); exit(0);

// ...................................................................

//                             Test Display Screen shows first one Tree.
//                             At ENTER the Run starts: Scrolling Screen.
Anfang:
if(test) {
	    RnS = (SeedS[unit]<<1)+1;
	    assign = SeedM[unit] & 1;
	    RnM = 0x0301 | SeedM[unit];
	 }

GetBit();
amp = 4;score = 0;
union REGS regs;
mode = 13;                    // Mode 13: 320 x 200 Screen
regs.h.al = (char) mode;
regs.h.ah = SETMODE;
int86(VIDEO,&regs,&regs);
farptr = (char far*) 0xA0000000;   // set ptr to EGA memory
ob(0x3ec,5);
ob(0x3ed,0); // mode 0
Settree();
getch();
//........................ Start of Run ...............................

stop = 0;                                  //      Run Starts at ENTER
s=1;
for(cycle=0;cycle<cycles;cycle++)
{ s = 1-s;
  for(k=0;k<64;k=k+1+fast)
     {                                           //   Start Half-Cycle
	colr = 15; // white trace
	if (A>4) colr = 14; // yellow
	if (A<4) colr = 12; // rust-red
	ob(0x3C4,2);	  // set color to write
	ob(0x3C5,colr);     //   into map mask register
	// 11 light-blue,12 rust-red,13 violet,14 yellow, 15 white
	x = k % 128;
	Rein(x+64*s);
	AllScroll();
     }
     int bb = 2*GetBit()-1;                                  //   End
Half-Cycle
//     if(aim) bb = -bb;
     amp = amp + bb;
     if(amp>7) amp=7;
     if(amp<1) amp=1;
     score = score + amp - 4;
     if(kbhit()) {j=getch();if((j>47)&&(j<58)) speed = j-48;}
}
score = (int) (100*score/sigma);
//if(aim) score = - score;
//   ........................End of Run ..............................

if(stop) goto NewSpeed;

 ob(0x3CE,5);  // RESET VIDEO, Waite II, pg 452  : doesn't help
 ob(0x3CF,0);

if(fast && speed<5) speed +=5;  // Speed change within group during run
if(!fast && speed>4) speed -=5;

sound(300);               //                       End-of-Run  Tone Signal
delay(20);
nosound();
//                             For TEST RUN record next Run Number on Disk
if(test)
     { testsc[unit] = score;}

else  { playsc[pzeiger] = score; pzeiger++; pcount++;
	if(pzeiger>20) {for(j=0;j<19;j++) playsc[j]=playsc[j+1];pzeiger=20;}
      }

getzeit();

asm {   mov ah,2		// Check if Printer is operating
	mov dx,0                // Set hasprint = 1 or 0
	int 17h
	mov hasprint,ax  }

hasprint = hasprint/256;  // 10010000 with printer, 11001000 without
	 // bit 6 : acknowledge, bit 4 : printer selected, bit 3 : I/O error
hasprint = hasprint & 0x58;
if(hasprint == 16) hasprint=1; else hasprint=0; // 1/0 for yes/no printer
if(aim) cha='L'; else cha='H';

	if(test)
	     {  unit++;
		fpdat = fopen(datpsi,"r+");
		ofdat = 18; fseek(fpdat,ofdat,0);      // new unit
		i = unit >> 4;
		ch = makehex(i); putc(ch,fpdat);
		ch = makehex(unit); putc(ch,fpdat);

		ofdat = 20+10*unit-2;    	// write info-byte
		fseek(fpdat,ofdat,0);
		i = 1 + speed + 16*(att + 8*aim);
		j = i >> 4;
		ch = makehex(j); putc(ch,fpdat);
		ch = makehex(i); putc(ch,fpdat);
		fclose(fpdat);
	    }

if(test)
  {	fprnt = fopen(druck,"a"); // open for append text
		if(aim) cha='L'; else cha='H';
	fprintf(fprnt,"\n\r%s%4d,%s%c,%s%2d,%s%s%s",
	"Score =",score," Aim: ",cha," Speed:",speed ,
		 ListA[att],",",zeit);
	fprintf(fprnt,"%s%3d","  Sla# ",unit-1);
	fclose(fprnt);
   }

if(hasprint)
{
	fprintf(stdprn,"\n\r%s%4d,%s%c,%s%2d,%s%s%s%s",
	"Score =",score," Aim: ",cha," Speed:",speed ,
				   ListA[att],",",zeit,"  Sla# ");
	if(test) fprintf(stdprn,"%2d",unit-1);
}

goto Setdat;
// .....................................................................

//                                            Optional Full Score Display

ScoreDisplay:
closegraph();// use text mode with colors
clrscr();
textcolor(13);
gotoxy(8,1);cputs("Scores in the last 20 Explore-Runs and in the up to 100
Record-Runs.");
gotoxy(1,4);cputs("Explore-Runs : (Results arer lost at Exit).");
textcolor(10);
gotoxy(60,6);PN(pcount);gotoxy(63,6);cputs("Explore-Runs");
z=0; for(j=0;j<20;j++) z += playsc[j];if(pcount>0) z = z/pcount;
gotoxy(60,7);cputs("Average =");gotoxy(70,7);if(k==0) k=1; PN(z);
for(j=0;j<10;j++) {gotoxy(4+5*j,6);PN(playsc[j]);}
for(j=0;j<10;j++) {gotoxy(4+5*j,7); PN(playsc[j+10]);}
textcolor(13);
if(hasfile)
{
gotoxy(1,10);cputs("Record-Runs : (Results are permanently saved.)");
textcolor(10);
for(j=0;j<100;j++) testsc[j] = 0;
for (j=0;j<unit;j++) testsc[j] = TotScore(j);
z=0; for(j=0;j<unit;j++) z += testsc[j]; if(unit>0) z = z/unit;
   gotoxy(60,12);PN(unit);gotoxy(63,12);cputs("Record-Runs");
   gotoxy(60,13);cputs("Average =");gotoxy(70,13); PN(z);

for(int kk=0;kk<10;kk++)
  { for(int jj=0;jj<10;jj++)
    {gotoxy(4+5*jj,12+kk);PN(testsc[jj+10*kk]);} }
}
else {gotoxy(10,15);cputs("No Data File: No Test Runs Available");};
// for(j=1;j<16;j++) {gotoxy(2*j,23);textcolor(j);cputs("XX");}
textcolor(14);
gotoxy(4,24);cputs("You can save the data via PrintScreen");
textcolor(3);
gotoxy(50,25); cputs("Press any key to continue");
Notaus:
getch();
closegraph();
goto Setdat;
}

