// c:\tc\Email\ Sparks  (with optional Mouse)
/*
	 Anzahl = Number of Game Runs is set by data file.
	 A seed number may be used repeatedly, so that each run
	 needs only one seed number and one spark may several times
	 show the same path length and waiting time.

Data-File Preparation:

1.  Program RnESpark.Bas (run on system with RNG)
	Generates original data files Spark-Or.001, Spark-Or.002,...
	ASCII-HEX format. First 2 bytes -> Anzahl = Number of runs.
	Then for each run 8 bytes (0,1,...F). Lowest bit of last byte = 1.
	This is the assignment bit for possible use with outside observer.

2.  File SparkLet: Letter to subject (prepared by EDIT)

3.  File CmbSpark.Cpp
	Combine SparkLet with Spark-Or.001 into file SparkDat.001
	The data-part of the file starts with  27496385SPK.001/
	Then follows xx = Anzahl, then Anzahl*8 Random bytes (0..F).
	File SparkDat.001 is e-mailed and stored under filename Sparkdat.

	 VGA:   320 x 200 screen with 256 colors : Borland Document 1031
	 EGAHI: 640 x 350
	 NEEDS LARGE MEMORY MODEL (Option C C)

	 For stand-alone program, I use under main the line
		if(registerbgidriver(EGAVGA_driver) < 0) exit(1);
	 (I used TLIB to ad to graph.lib the files EGAVGA.obj and SANS.obj.)


	 Short-Run Durations (sec)  Mode  66 Mhz  33 Mhz
				     1      30      34
				     2      32      43
				     3      30      35
				     4      31      41
				     5      34      54
				     6      35      40
				     7      34      43
				     8      34      52
				     9      33      70

	Data file "Sparkdat.psi" has the following structure:
		2 bytes unit number (initialed to 0)
		2 bytes -> Anzahl = available recorded runs
		followed by a number Anzahl of sets of
			8 bytes random numbers
			2 byte for test parameters (initialed to 0)

	Data File "PrntSprk.psi" stores score, highscore, waitscore,
					    time, etc for TEST RUNS

	 z0 = 0,...8     sets test type 1,...,9


FILE *fptr,*fpdat,*fprnt;
char dat[] = "sparkdat";   	//fptr
char datpsi[] = "sparkdat.psi"; //fpdat

Layout:

	main()
		hasfile = 0
		if(datpsi exists) hasfile = 1;
		if(!hasfile && dat exists)
		   { hasfile = 1; generate file datpsi}

		if(hasfile)
		   { open datpsi;
		     read in values for Anzahl, unit, RnS0, RnM0
		     close datpsi}

		load SdS and SdM from random(256)

	Anfang:
		Start, make selections
		Select test/play: test = 1/0
		if(unit = Anzahl) test = 0;
		if(!hasfile) test = 0;
		if(test) {RnS = RnS0; RnM = RnM0;}

		D I S P L A Y   R U N

		if(test)
		   { unit++;
		     open datpsi;
		     store unit value;
		     if(unit<Anzahl) { load next RnS0, RnM0;}
		     close datpsi;}

		 goto Anfang:

*/

void GrInit(void);
void GrClose(void);
void PP(unsigned int x, unsigned int y, unsigned char color);

#include <stdlib.h>
#include <dos.h>
#include <math.h>   	// abs()
#include <conio.h>	// getch()
#include <stdio.h>  	//stdout.
#include <iostream.h>	// cout <<
#include <fstream.h>
#include <time.h>
#include <process.h>    // for exit() only temporaryly used
#include <graphics.h>
#include <io.h>		// access
#define RatInt geninterrupt(0x33)
#define ot outtextxy

int Anzahl ;	  // Number of units = game-runs in data file
int runsleft;
const int   unimax = 500; // Trials in unit
const int LongPrnt = 1;   // Set to 1/0 for long/short(subject) printout
int mark1=4,mark2=12,mark3=10; // set initiallly Type 4, Explore, short run
int durFac;		  // duration factor 1 or 2 for 1/2 or 1 minute
int unitr;       	  // 0,1,..499 counts trials in unit
int hasfile;             // 1 if Data File exists, 0 else
unsigned int hasprint;   // 1 if printer operating, 0 else
unsigned long SdM, SdS;		// 16-bit seeds
int assign;		// = zero bit of SdM holds outsider's assignment
int test;               // test = 1 if hasfile and Game selectiom
unsigned int unit;		// holds current unit number, 0,1,2,..
			// stored in bytes 0,1 of data file
			// bytes 2,3 not used
FILE *fptr,*fpdat,*fprnt;
char dat[] = "sparkdat";   	//fptr
char datpsi[] = "sparkdat.psi"; //fpdat
char druck[] = "prntsprk.psi";   //fprnt
char typus[] = "27496385spk-001/";//is updated,used as head of prntspk.psi


unsigned char ch;	// reads data from file

union REGS regs;     //                    y
const int Xbase = 160;     //              |
const int Ybase = 190;     //	___________|_____________ x
int rowOffset[200];
char pl[40][3];  // 40 instead of the maximal 256
int i,j,k,q;
int x,y;
float phi, C[64], S[64];
const float pi = 3.14159;
int BahnX[64][160], BahnY[64][160];
const int xmax = 158;
float t0;
float Score, WaitSc, CntrSc;
float DScore,WScore,CScore,Sig,z,zh,zw;
int MaxsTry;		// Trials in run
int del ;		// determines speed
int Zahl;		// number of sparks
const wart = 10;		// waiting factor
int Male;		// Number of units in run
int ZahlT[] = {40,40,80,80,80,160,160,160,160};
int delT[]  = {10,5,20,10,5,48,22,10,4};
int einheitT[] = {1,2,1,2,4,1,2,4,8};// 1 = 500 trials
int durT[]  = {1,2,4,8};
int z0;  // holds selectio z0=1,..,8 for winzahl = 1,...,9
int steps, Ende;
const long P = 524287;		// prime 2^19-1
const int PA = 79, PB = 3067;
long RnM, RnS, Rn, RnS0, RnM0;			// rn's for multipl./shift algorithm
unsigned int hold1;
long int ofdat; //  data offsett
char chp[17]; // for itoa
char text[20];
char ch0, ch1,ch2,ch3;
char let[2] = {'X','\0'};
char far *farptr = (char far*) 0xB8000000;// base of color text memory

int mul[] = {2,6,7,8};		// for random type sequencing
int mu;

int gdriver, gmode;
int rat = 1; // set to 0 if no mouse available
int ratX, ratY, ratBut, letKey;
int wahl;
int winzahl;//  1,2,..13
int table[] = {0,17,18,19,20,21,22,23,24,25,83,76,69,82,0,88};
char art[] = {'1','2','3','4','5','6','7','8','9'};
char zeit[16];
char Ito[17]; // for itoa
int xx;
float xfl;

int max  = 1000;	// 20 sec run time for max = 1000  needed ?????????

void p(int jc,char* pt) {gotoxy(1,jc);cputs(pt);}

void getzeit()
     {                         // Enters current time into zeit[15]
	zeit[15] = '\0';
	struct tm *ptr;
	time_t lt;
	lt = time(NULL);
	ptr = localtime(&lt);
	for(int j=0;j<15;j++) zeit[j] = asctime(ptr)[j+4];
     }

void ActRat()  { if(rat) {_AX = 32; RatInt;}  }

int ResRat()   { _AX = 0;  RatInt; return(_AX);} // returns 0 if no mouse

void ShowRat() { if(rat) {_AX = 1;  RatInt;}  }

void HideRat() { if(rat) {_AX = 2;  RatInt;}  }

void ReadRat(int *h, int *v, int *but)    // ReadRat(&ratX,&ratY,&ratBut)
       { if(rat) { int temp;                // reads the Rat Status
		 _AX  = 3  ; RatInt;
		 temp = _BX; *but = temp;
		 *h   = _CX;
		 *v   = _DX;             } }

void Shift()
   {   unsigned int hold1 = (RnS & 1) << 3;
       hold1 = (RnS & 8) ^ hold1;
       RnS = RnS >> 1;
       if(hold1 & 8) RnS = RnS | 0x100;
   }

void AnyBut()  // This waits for keypress from Mouse or Keyboard-letter.
	       // Sets values into ratX,ratY,ratBut
	       // for keybord input letkey>0 and letkey = ASKIIcode

	{   ActRat(); ShowRat();
	    ratBut = 0; letKey = 0;
	    while(!(ratBut || letKey))
	      { Shift(); ReadRat(&ratX, &ratY, &ratBut);
		if(kbhit()) {letKey = getch();} }
	    letKey = letKey & 0x00DF;
	}                               // convert to all capital letters

// ..............................
class Window
   {	private:
	int x0,y0,w0,h0;  // left top at x0,y0, width w0, height h0
	int winu0;        // call letter as ASCII = window number
	int winz0;     // counts windows 1,2,3..
	int col0;         // background color
	public:

	void setwin(int xw,int yw,int ww,int hw,int winu,int winz,int colw)
	 { x0=xw; y0=yw; w0=ww; h0=hw; winu0=winu; col0=colw;winz0=winz;}

	void show()    // display the window with thin white frame
	{ int rect[8];setcolor(15);
	  HideRat();rect[0]=x0;rect[1]=y0;rect[2]=x0+w0;rect[3]=y0;
	  rect[4]=x0+w0;rect[5]=y0+h0;rect[6]=x0;rect[7]=y0+h0;
	  setfillstyle(1,col0);fillpoly(4,rect);ShowRat();        }

	void mark(int colw)  // set farme in any color
	{ HideRat();setlinestyle(SOLID_LINE,0,THICK_WIDTH);setcolor(colw);
	  moveto(x0,y0); lineto(x0+w0,y0);lineto(x0+w0,y0+h0);
	  lineto(x0,y0+h0);lineto(x0,y0); ShowRat();              }

	void unmark()  // set farme in thin white color
	{ HideRat();setlinestyle(SOLID_LINE,0,THICK_WIDTH);setcolor(0);
	  moveto(x0,y0); lineto(x0+w0,y0);lineto(x0+w0,y0+h0);
	  lineto(x0,y0+h0);lineto(x0,y0);
	  setlinestyle(SOLID_LINE,0,NORM_WIDTH);setcolor(15);
	  moveto(x0,y0); lineto(x0+w0,y0);lineto(x0+w0,y0+h0);
	  lineto(x0,y0+h0);lineto(x0,y0);  ShowRat();    }

   int hit()
			// If I try to incorporate keyboard detection
			// into hit(), the response to key press
			// takes about 1 second. WHY ???
     { int raus = 0;
       ReadRat(&ratX, &ratY, &ratBut);
       if((x0<ratX) && (ratX<x0+w0) && (y0<ratY) && (ratY<y0+h0) && ratBut )
	    { raus=1; wahl = winu0; winzahl = winz0;}
       return(raus);
     }
   } ;
// ................end class Window .............

int iszahl(unsigned char c0)		//  48..57  65..70 (ASCII)
   { int is1=1;                         //   0...9   A...F
     if(c0<48 || c0>70 || (c0<65 && c0>57)) is1=0;
     return is1;
   }

int Getc(FILE *fp)    // ignore non-hex-numbers
   { int gtc = 0, gt;
     while(gtc==0) { gt = getc(fp); gtc = iszahl(gt);}
     return gt;
   }

int makezahl(unsigned char chx)          // transform char 0,1,..,F into
number
   {
     int anz = chx-48;
     if (anz > 16) anz -=7;
     return anz;            }


unsigned int holint()
    {
	unsigned int uni = makezahl(getc(fpdat)); uni = uni <<4;
	uni += makezahl(getc(fpdat));
	return uni;
    }

unsigned int makehex(unsigned int xx) // ret.lowest 4 bits of xx as Ascii-Hex
    {  xx = xx & 15; xx += 48; if(xx>57) xx += 7; return xx; }

int nextType(int zz)
      {	zz++; zz = (zz*mu) % 11;
	while(zz>9) {zz = (zz*mu) % 11;}
	return(zz-1);               }


void seed()
	{ RnS = (SdS << 1) + 1; RnM = SdM + 0x0300; }

void nextRn()
    {
       unitr++;                       	// trial counter within unit
       if(unitr == unimax) unitr = 0;
       RnM = (RnM*PA) % P; RnM = (RnM*PB) % P;
       hold1 = (RnS & 1) << 3;
       hold1 = (RnS & 8) ^ hold1;
       RnS = RnS >> 1;
       if(hold1 & 8) RnS = RnS | 0x100;
       Rn = (RnS ^ RnM) & 0xFFFF;
    }

/* Shift Register (17 bits):

	^ 16  15 14  ......  3   2   1   0
	|____________________|___________|

nextRn() repeats after about 2^36 = 68,000,000,000 = 68 billion steps,
with 2^32 = 4.29 billion entry points.

*/

void GrInit()
{
	for(i=0; i<200; i++) rowOffset[i]=i*320;
	_AH=0;
	_AL=0x13;
	geninterrupt(0x10);
}

void GrClose()             	//set to 80*25 Color Text
{	_AH=0;
	_AL=0x3;
	geninterrupt(0x10);
}

void PP(int x, int y, int color)        // Plot Point
    {	*((char far *) 0xA0000000L + (x+Xbase+rowOffset[Ybase-y]))=color; }

void SetAllColors(char (*pl)[3])   // enter the colors of pl[256][3]
{                                  // into the "palette"
	_ES=FP_SEG(pl);
	_DX=FP_OFF(pl);
	_AX=0x1012;
	_BX=0;
	_CX=  40; // = 256;  we don't need all 256 colors
	geninterrupt(0x10);
}

void GetAllColors(char (*pl)[3]) //  not used, what does it do
		      // does it get the initial standard colors??
{	_ES=FP_SEG(pl);
	_DX=FP_OFF(pl);
	_AX=0x1017;
	_BX=0;
	_CX=  40; // =256;  not all 256 colors needed
	geninterrupt(0x10);
}
// ......................
class Bahn
{
private:
	int DownCount; 	// initial to Male-1
	int rnlHold;    // initial to rnl
	int rnwHold;    //            rnw
	int rncHold;
	int t;		// step counter 0,1,2,..tmax
	float tmax;     // Bahn remains active until t = tmax
	int ph;         // Start direction of Bahn

	int rnl;         // rn = 0,1,...15   bahn-length
	int rnc;        // rnc = 0,.. 15  determines direction
			// 15 = near center, 0 = far sides
	int rnw;	// 0..15,  (15-rnw)*wart = wait time to start
	float len;      // flare on until t = len
	int farbe;
	int holdX[5], holdY[5]; // store past positions
	int jj;
	int Dx;
public:
	void init(void)
	{
	   if(steps == unimax) { Ende--;t = -2000; return; }
	   steps++;
	   DownCount = Male - 1;
	   nextRn();
	   rnl = Rn & 0x0F; Rn = Rn >> 4;
	   rnw = Rn & 0x0F; Rn = Rn >> 4;
	   rnc = Rn & 0x0F;
	   if(assign==0) { rnl = 15-rnl; rnw = 15-rnw; rnc = 15-rnc;}
	   rnwHold = rnw; rnlHold = rnl; rncHold = rnc;
	   WaitSc += rnw;     // high score = short wait-for start time
	   Score  += rnl;     // measures bahn-length
	   CntrSc += rnc;
	   t = -wart*(15-rnw); // set start delay
	   ph = 31 + (2*random(2)-1)*(31-2*rnc)+ random(2);// start angle
	   tmax = xmax*S[ph];
	   len  = tmax*(1+rnl)/16.0 -6;
	   farbe = random(16) + 8;
	   holdX[0]=holdX[1]=holdX[2]=holdX[3]=holdX[4]=0;
	   holdY[0]=holdY[1]=holdY[2]=holdY[3]=holdY[4]=0;
	   Dx = 0;
	   if(z0<2||z0==4||z0==8) Dx = random(32) - 16;
	}
/*
     phi = 0, 1, 2, ..... 31 || 32 ....... 62, 63
     phi = 30,31,32,33  = 31 +/- 1 +0/1   Score 15
     phi = 28,29,34,35  = 31 +/- 3 +0/1
     phi =  2, 3,60,61  = 31 +/-29 +0/1
     phi =  0, 1,62,63  = 31 +/-31 +0/1   Score 0
     Score = rnc = 0,...,15
     phi = 31 + (2*random(2)-1)*(31-2*rnc) + random(2)
*/

	void repeat(void)
	{
	   DownCount--;
	   rnw = rnwHold; rnl = rnlHold; rnc = rncHold;
	   t = -wart*(15-rnw); // set start delay
	   ph = 31 + (2*random(2)-1)*(31-2*rnc)+ random(2);// start angle
	   tmax = xmax*S[ph];
	   len  = tmax*(1+rnl)/16.0 -6;
	   farbe = random(16) + 8;
	   holdX[0]=holdX[1]=holdX[2]=holdX[3]=holdX[4]=0;
	   holdY[0]=holdY[1]=holdY[2]=holdY[3]=holdY[4]=0;
	   Dx = 0;
	   if(z0<2||z0==4||z0==8) Dx = random(32) - 16;
	}

	void sett(int kk) { t = kk; }
	void randdel() { t = t - random(10);}

	void onestep(void)
	{
	  t++;
	  if(t < 0) return;
	  PP(holdX[0], holdY[0], 0);	// erase point at end of chain
	      holdX[0] = holdX[1];     // 0 <- 1 <- 2 <- 3 <- 4
	      holdX[1] = holdX[2];
	      holdX[2] = holdX[3];
	      holdX[3] = holdX[4];
	      holdY[0] = holdY[1];     // 0 <- 1 <- 2 <- 3 <- 4
	      holdY[1] = holdY[2];
	      holdY[2] = holdY[3];
	      holdY[3] = holdY[4];
	   int len0 = 4;        // len0 = 1,2,3,4 possible spark lengths
	   if(z0<2||z0==4) len0=2;
	   if(z0==8) len0 = 1; // shorter sparks in these cases
	   holdX[len0] = BahnX[ph][t] + Dx;
	   holdY[len0] = BahnY[ph][t];
	   if(t<len && t>5) PP(holdX[len0], holdY[len0], farbe); // set point
	   if(t>xmax)
	      {	if (DownCount > 0) repeat(); else init();}
	 }
}   ;
//.............. end class Bahn

void main()
{
if(registerbgidriver(EGAVGA_driver) < 0) exit(1);
// I used TLIB to ad to graph.lib the files EGAVGA.obj and SANS.obj.
unitr = 0;
winzahl=4; // initial selection
z0 = winzahl-1;    // winzahl-1
ch2 = 83;          // Short Runs
durFac=1;
ch3 = 69;  	  // Explore-setting
Window W[20];
gdriver = VGA; gmode = EGAHI; // Screen 640 x 350
	    unsigned long Q = 0;
	    unsigned long lock = (9+16*(4+16*(7+2*16)));
	    lock = 6+16*lock;
	    lock = 3+16*lock;
	    lock = 8+16*lock;
	    lock = 5+16*lock;  // lock = HEX{27496385}
test = 0;

	randomize();
	mu = mul[random(4)];
	struct tm *ptr;			// print data and time
	time_t lt;
	lt = time(NULL);
	ptr = localtime(&lt);

//......................................................
hasfile = 0;      // Test if data file is present, set hasfile = 0/1
if(!access(datpsi,0)) hasfile=1;// needs io.h  (Compl.Refer.pg346)
			// access(. ,0) = 0 if file is present !
long ofdat = 0, ofin = 0;
int anf = 0, ende = 0;
//.................... generate file sparkdat.psi if appropriate........
if(!hasfile && !access(dat,0))
  {      fpdat = fopen(datpsi,"wb");	//sparkdat.psi
	 fptr  = fopen(dat,"rb+");       //sparkdat
	 // needs BINARY file to make ftell(fpdat) work right
	 fprnt = fopen(druck,"w");      //prntswng
	 fseek(fptr,ofin,0);
	 fseek(fpdat,ofdat,0);
     while(!feof(fptr) )
	    {  if(!feof(fptr)) {ch = getc(fptr); }
	      if(iszahl(ch)) { Q = Q<<4; Q += makezahl(ch);} else Q=0;
	      if(Q == lock) {ende=1;break;}
	    }
  if(ende)
   { ofin = ftell(fptr)-8; fseek(fptr,ofin,0);
		// sets file pos.indicater to start of code 274..
     for(i=0;i<16;i++){ch=getc(fptr);putc(ch,fpdat);typus[i]=ch;}
     for(i=0;i<2;i++) {ch=Getc(fptr);putc(ch,fpdat);}
     ch0 = '0'; for(i=0;i<2;i++) putc(ch0,fpdat);
     fprintf(fprnt,"%s",typus);  fclose(fprnt);
     i=0;
     while(!feof(fptr))
	    {  if(!feof(fptr)) ch = getc(fptr);
	       if(iszahl(ch))
		{i=(i+1)%8; putc(ch,fpdat);
		 if(i==0){putc(ch0,fpdat);putc(ch0,fpdat);}}
	    }
     // disable the file sparksdat by changing the code 27496385 -> 07496..
     fseek(fptr,ofin,0); ch = '0'; putc(ch,fptr);
     fclose(fptr);fclose(fpdat);
     hasfile = 1;
   }
  }


if(hasfile)
{	fpdat = fopen(datpsi,"r+");
	int ofdat = 16; fseek(fpdat,ofdat,0);
	Anzahl = holint();
	unit = holint();
	runsleft = Anzahl - unit; // if full then unit = Anzahl
	if(runsleft)
	  { ofdat = 20+ 10*unit; fseek(fpdat,ofdat,0);
			SdS = holint();
			SdS = SdS << 8;
			SdS += holint();
			SdM = holint();
			SdM = SdM << 8;
			SdM += holint();
			RnS0 = (SdS << 1) + 1;
			assign = SdM & 1;
			SdM = SdM | 1; // SdM.0 for optional later assignment
			RnM0 = SdM | 0x0300;
	   }
	 fclose(fpdat);
}


	Bahn bahn[160];
	Score = WaitSc = CntrSc = 0;
	for(j=0;j<64;j++)
	  { phi = pi*(1 + 0.0317 * j)/4;
	    C[j] = cos(phi);
	    S[j] = sin(phi); }

	for(j=0;j<64;j++)
	  {  for(t0=0;t0<160;t0++)
	      {  BahnX[j][t0] = (int) (2*C[j]*t0);
		 BahnY[j][t0] = (int) (2*(S[j]*t0- t0*t0/(2*xmax)));
	      }
	  }

SdS = random(256); SdM = random(256);
RnS = (SdS << 1) + 1; RnM = SdM | 0x300;

//............... First Page at Power-Up ............................
clrscr();
//for(q=0;q<16;q++) {textcolor(q);gotoxy(20+2*q,1);cputs("X");}
textcolor(13);
p(2,"                            Experiment:  SPARKS");
for(j=0;j<32;j++) {q = j % 8 + 8;textcolor(q);gotoxy(22+j,4);cputs(".");}
textcolor(11);
p(7,"                              Helmut Schmidt");
p(8,"                                P.O.Box 296");
p(9,"                              Mora, NM 87732");
p(10,"                              (505) 387-2184");
p(11,"                            psischmidt@aol.com");
textcolor(10);
p(15,"          See the File README for General Information on the
Experiments");
p(17,"          Read File Sparks.Txt for Details on this Experiment SPARKS");
p(19,"               Turn the Printer on if you want a Printed Record");
textcolor(11);
if(!hasfile)
{ p(21,"                    No Data Files: Only Explore-Runs are
available.");}
else { p(21,"                 Number of still Available Record-Runs :");
       gotoxy(60,21);cputs(itoa(runsleft,Ito,10));}
textcolor(14);
p(24," Press X to EXIT Program.                       Press any Key to
Continue");
ch0 = getch(); if(ch0=='X' || ch0=='x') {textcolor(15);clrscr();exit(0);}
//..................................................................


Anfang:

initgraph( &gdriver, &gmode, " ");
W[1].setwin(194,36,60,24,17,1,1);		   // '1' & 0xDF = 17
W[2].setwin(274,36,60,24,18,2,1);
W[3].setwin(194,66,60,24,19,3,1);
W[4].setwin(274,66,60,24,20,4,1);
W[5].setwin(354,66,60,24,21,5,1);
W[6].setwin(194,96,60,24,22,6,1);
W[7].setwin(274,96,60,24,23,7,1);
W[8].setwin(354,96,60,24,24,8,1);
W[9].setwin(434,96,60,24,25,9,1);  		   // '9' & 0xDF = 25
W[10].setwin(194,140,125,25,83,10,1);               // Short Run
W[11].setwin(334,140,125,25,76,11,1);              // Long Run
W[12].setwin(194,210,110,26,69,12,1);               // 'e'          69
W[13].setwin(320,210,95,26,82,13,1);               // 'r'          82
W[14].setwin(130,270,175,60,0,14,1);         // Space-Bar & 0xDF =  0
W[15].setwin(400,270,110,60,88,15,1);              // 'x' & 0xDF = 88
W[16].setwin(30,245,100,40,78,16,1);		// N
W[17].setwin(155,245,135,40,0,17,1);		// Space Bar
W[18].setwin(315,245,130,40,13,18,1);		// Enter
W[19].setwin(470,245,90,40,88,19,1);		// X

for(j=1;j<16;j++) W[j].show(); // frame set color 15 = white
setcolor(13);
ot(10,10,"Display Options: Select one by Number or Mouse-Click");
setcolor(14);
ot(80,45," 40 Sparks");
ot(200,40,"medium");		//  40 Sparks     1    2
ot(280,40," fast");             //  80 Sparks     3    4    5
ot(280,50,"   2");              // 160 Sparks     6    7    8   9
ot(200,50,"   1");              // Short/Long    10   11
ot(80,75," 80 Sparks");         // Explore/Record   12     13
ot(200,70," Slow");             // Run / Exit       14     15
ot(200,80,"   3");              // winzahl = 1...15
ot(280,70,"medium");
ot(280,80,"   4");
ot(360,70," fast");
ot(360,80,"   5");
ot(80,105,"160 Sparks");
ot(200,100," Slow-");
ot(200,110, "   6");
ot(280,100," Slow");
ot(280,110,"   7");
ot(360,100,"medium");
ot(360,110,"   8");
ot(440,100," fast");
ot(440,110,"   9");
setcolor(13);
ot(10,145,"Select Run Length:");
setcolor(14);
ot(194,145," Short: 35 sec     Long: 70 sec");
ot(194,155,"      S                 L");
setcolor(13);
ot(10,185,"Explore- or Record-Run: Select E or R,  begin with E-Runs.");
setcolor(14);
ot(200,215," Explore Run    Record Run");
ot(200,225,"    E               R");
setcolor(13);
ot(10,280,"Ready to go:");
setcolor(14);
ot(140,280,"To Start the Run                  To EXIT");
ot(140,295,"Click this Field or               Click here");
ot(140,314,"Press the Space-Bar               or Press X");
ResRat();ActRat();
ratX=ratY=ratBut=0;
ShowRat();
ratX=ratY=ratBut=0;
W[mark1].mark(13);
W[mark2].mark(13);
W[mark3].mark(13);
Wiederhol:
while(!(W[15].hit() || W[2].hit() || W[3].hit() || W[4].hit() || W[5].hit()
     || W[6].hit() || W[7].hit() || W[8].hit() || W[9].hit() || W[10].hit()
     || W[11].hit() || W[12].hit() || W[13].hit() ||
	W[14].hit() || W[1].hit() || kbhit() )) {Shift();}
if(kbhit())
     {  k = getch() & 0xDF;
	int mk = 0, ml;
	for(j=1;j<16;j++)
	  {if(k==table[j]) {mk=1;ml=j;}}
	if(mk==1) winzahl=ml;
     }

while(kbhit()) getch();
if(winzahl<10)
  {for(j=1;j<10;j++) W[j].unmark();
   W[winzahl].mark(13);z0 = winzahl-1; mark1=winzahl;goto Wiederhol;}
if(winzahl==10)
	{durFac=1;ch2=83;mark3=10;W[11].unmark();W[10].mark(13);}
if(winzahl==11)
	{durFac=2;ch2=76;mark3=11;W[10].unmark();W[11].mark(13);}
if(winzahl==12)
  {ch3=69;W[13].unmark();W[12].mark(13); mark2=12; goto Wiederhol;} // E
if(winzahl==13)
  {ch3=82;W[12].unmark();W[13].mark(13); mark2=13;goto Wiederhol;} // R
if(winzahl == 15) {closegraph();clrscr();exit(0);}
if(!(winzahl==14)) goto Wiederhol;

// int z0 = 0,1,2..8 = test type
// for Explore/Record   mark2= 12/13, ch3 = 69/82
Backdoor:
	del = delT[z0];                // del = 2,5,10,20
	Zahl = ZahlT[z0];              // Zahl = 20,40,80,160
	Male =  durFac*einheitT[z0]; // number of 500 trial units
//	MaxTry = 500 * Male;
Nochmal:
	test = 0;
	if(hasfile && (ch3 == 82) && runsleft) test = 1;
	Score = WaitSc = CntrSc = 0;
	clrscr();
HideRat();
clrscr();
setcolor(1);
setlinestyle(SOLID_LINE,0,THICK_WIDTH);
rectangle(1,1,638,348);
setfillstyle(SOLID_FILL,0);
floodfill(100,100,1);

// for(j=0;j<16;j++) {setcolor(j);ot(20*j,5,"XX");} // color sample
	setcolor(2);
	ot(10,30,"Wait a moment and relax before starting the run.");
  ot(10,50,"The goal is to have the sparks flying wide, high and to the
sides.");
  ot(10,70,"Dont push too hard. Rather enjoy the sparks very actively.");
  ot(50,280,"Press Any Key or the Mouse Button to Start Run");
	if(test)
	  {  i = Anzahl-unit;
	     if(i<0) i=0;
	     ot(350,310,"Remaining RECORD-RUNS : ");
	     ot(550,310,itoa(i,chp,10));
	   }
	if((ch3==82) && (test==0))
	{  ch3=69; ot(350,310,"Only EXPLORE-RUNS available"); }
ResRat(); AnyBut();
	if(!test) seed()		; 	// seed my quasi-RNG (RnS,RnMS <= Sds,SdM
	closegraph();
	GrInit();

	pl[5][0]=60;pl[5][1]=60;pl[5][2]=60;// color5 = white
	pl[6][0]=20;pl[6][1]=20;pl[6][2]=20;// color6 = grey
	pl[7][0]=40; pl[7][1]=23; pl[7][2]=0; // yellow-gold = 7 = text
	pl[8][0]=0 ; pl[8][1]=63; pl[8][2]=0; // green  =  8
	pl[9][0]=30 ; pl[9][1]=30 ; pl[9][2]=63;// blue   =  9
	pl[10][0]=63; pl[10][1]=0 ; pl[10][2]=0; // red = 10
	pl[11][0]=63; pl[11][1]=63 ; pl[11][2]=20; // yellow
	pl[12][0]=63; pl[12][1]=0 ; pl[12][2]=63; // violet
	pl[13][0]=0; pl[13][1]=63 ; pl[13][2]=63; // sky-blue
	pl[14][0]=63; pl[14][1]=21; pl[14][2]=23; // red-brown
	pl[15][0]=63; pl[15][1]=47 ; pl[15][2]=10; // gold
	pl[16][0]=63 ; pl[16][1]=63; pl[16][2]=63; // white
	pl[17][0]=0 ; pl[17][1]=0 ; pl[17][2]=63;// blue
	pl[18][0]=63; pl[18][1]=63 ; pl[18][2]=0; // yellow
	pl[19][0]=63; pl[19][1]=60 ; pl[19][2]=50; // grey
	pl[20][0]=63; pl[20][1]=40 ; pl[20][2]=63; // light violet
	pl[21][0]=20; pl[21][1]=63 ; pl[21][2]=63; // sky blue
	pl[22][0]=0; pl[22][1]=63; pl[22][2]=0; // green
	pl[23][0]=63; pl[23][1]=20 ; pl[23][2]=63; // purple

	SetAllColors(pl);

//....................Display Running...........................

	if(test) {RnS = RnS0; RnM = RnM0; }
	Ende = ZahlT[z0]; 	// Number of sparks
	steps = 0;
	while(kbhit()) getch();
	  // initial the number of bahn required, with random start delay
	for(int b=0;b<Zahl;b++) { bahn[b].init();bahn[b].randdel();}
	  // run to end unless key pressed
	while((steps<unimax) && !kbhit())
	{   for(j=0;j<Zahl;j++) { bahn[j].onestep();}
		delay(del);
	}
	if(!kbhit())
	    {	for(j=0;j<100;j++)
		{   for(int b=0;b<Zahl;b++) { bahn[b].onestep();}
		   delay(del);
		}  delay(100);
	    }
	else {getch();test = 0;} // If interrupted, declare play run
//................... End of Display Run ............................

	DScore = 2*Score - 15*steps;
	WScore = 2*WaitSc - 15*steps;
	CScore = 2*CntrSc - 15*steps;
	Sig = sqrt(170.0*steps);
	z = (DScore+WScore)/Sig;
	zw = WScore/Sig;
	int zi = (int) (100*z);	// z = zh + zw = highscore+waitscore
	int zwi = (int) (100*zw);
	int zhi = zi - zwi;
	GrClose();
	delay(500);

hasprint = hasprint/256;  // 10010000 with printer, 11001000 without
	 // bit 6 : acknowledge, bit 4 : printer selected, bit 3 : I/O error
hasprint = hasprint & 0x58;
if(hasprint == 16) hasprint=1; else hasprint=0; // 1/0 for yes/no printer

	if(test)
	     {  unit++;
		fpdat = fopen(datpsi,"r+");
		ofdat = 18; fseek(fpdat,ofdat,0);
		int xxx = unit >> 4;
		ch = makehex(xxx); putc(ch,fpdat);
		ch = makehex(unit); putc(ch,fpdat);

		ofdat = 20+10*unit-2;  	// write info-byte. unit = 1,2,..
		fseek(fpdat,ofdat,0);
		j = z0+1+16*durFac;// z0+1 = 1,..9= type, DurFac = 1,2
		xxx = j >> 4;
		ch = makehex(xxx); putc(ch,fpdat);
		ch = makehex(j); putc(ch,fpdat);

		if(unit<Anzahl)
		{
		ofdat = 20+ 10*unit; fseek(fpdat,ofdat,0);
			SdS = holint();
			SdS = SdS << 8;
			SdS += holint();
			SdM = holint();
			SdM = SdM << 8;
			SdM += holint();
			RnS0 = (SdS << 1) + 1;
			assign = SdM & 1;
			SdM = SdM | 1; // SdM.0 for optional later assignment
		 }	RnM0 = SdM | 0x0300;
		 fclose(fpdat);
	     }

initgraph( &gdriver, &gmode, " ");
ActRat();ShowRat();
clrscr();
setcolor(1);
setlinestyle(SOLID_LINE,0,THICK_WIDTH);
rectangle(1,1,638,348);
setfillstyle(SOLID_FILL,0);
floodfill(100,100,1);
setlinestyle(SOLID_LINE,0,NORM_WIDTH); // works for window frame?
for(j=16;j<20;j++) W[j].show();
//	for(j=0;j<16;j++) {setcolor(j);ot(20*j,5,"XX");}
	setcolor(2);
	ot(10,30,"S C O R E  = ");
	ot(130,30,itoa(zi,chp,10));
	ot(250,50,"A high positive Score was the Goal of the Game");
	ot(250,30,"A score of 100 equals one standard deviation");
	ot(250,90,"Choice : ");
	let[0] = art[z0];
	ot(340,90,let);
	while(kbhit()) getch();
	if(ch3==69) ot(10,110,"Explore-Run");
	      else  ot(10,110,"Record-Run");
	if(kbhit()) getch();
	ch0 = art[z0];

asm {   mov ah,2		// Check if Printer is operating
	mov dx,0                // Set hasprint = 1 or 0
	int 17h
	mov hasprint,ax  }

hasprint = hasprint/256; hasprint = hasprint & 0x58;
if(hasprint == 16) hasprint=1; else hasprint=0;

getzeit();
if(hasprint)
     {
	fprintf(stdprn,"\n\n\r%s%4d,%6d%4d,%s%4d,%s%c%c%c,",
	   "Score=",zi,zhi,zwi,"  Try=",steps," Type= ",ch0,ch2,ch3);
	fprintf(stdprn,"%s%s%s","  ",zeit,"  SPK# ");
	if(test) fprintf(stdprn,"%3d",unit-1);
     }
if(test)
     {
	fprnt = fopen(druck,"a"); // open for write as textfile
	fprintf(fprnt,"\n\n\r%s%4d,%6d%4d,%s%4d,%s%c%c%c,",
	   "Score=",zi,zhi,zwi,"  Try=",steps," Type= ",ch0,ch2,ch3);
	fprintf(fprnt,"%s%s","  ",zeit);
	fprintf(fprnt,"%s%3d", "SPK# ",unit-1);
	fclose(fprnt);
     }

setcolor(3);
ot(40,250,"New Choice:     For Same Run        Random Select       For
Exit");
ot(40,260,"Click or        Click or            Click or            Click
or");
ot(40,270,"Push: N         Push: Space-Bar     Push: Enter         Push: X
");

ResRat();ActRat();
ShowRat();
ratX=ratY=ratBut=0;
while(!(W[16].hit() || W[17].hit() || W[18].hit() || W[19].hit() ||
	kbhit() )) { ReadRat(&ratX,&ratY,&ratBut);SdM++;}
if(kbhit())
     {	ch = getch() & 0xDF;
	if(ch == 78) winzahl = 16;
	if(ch == 0 ) winzahl = 17;
	if(ch == 13) winzahl = 18;
	if(ch == 88) winzahl = 19;
     }

if(winzahl == 16) {closegraph(); goto Anfang;}   // N: New Run Selection
if(winzahl == 17)  goto Nochmal; // Space-bar: Same Run again
if(winzahl == 18){z0 = nextType(z0);goto Backdoor;} // Enter: Random select
closegraph();
clrscr();
 }

